#include "item.h"

Item* new_item() {

	Item* new = (Item*) g_malloc(sizeof(Item));

	new->name = g_string_new("new item");
	new->x = 0;
	new->y = 0;
	new->width = 0;
	new->height = 0;
	new->state = (0x0000);
	new->sprites = g_ptr_array_new();
	new->sprite_cnt = 0;
	new->sprite_cur = 0;
	new->properties = (0x0000);
	new->kind = NEW_ITEM;
	new->access = (0x0000);
	new->weight = 0;
	new->max_hp = 1;
	new->cur_hp = 1;
	new->armor = 0;
	new->inbag_cnt = 0;
	new->inbag_mask = (0x0000);
	new->inbag = g_ptr_array_new();
	new->stacked = NULL;
	new->where = 0;
	new->inside = NULL;

}

void zap_item(Item* item) {


	if(item != NULL) {

		if(item->name != NULL) {
			
			g_string_free(item->name,TRUE);
			item->name = NULL;
		
		}

		if(item->sprites != NULL) {

			g_ptr_array_free(item->sprites,FALSE);
			item->sprites = NULL;
			
		}

		if(item->inbag != NULL) {
		
			g_ptr_array_free(item->inbag,FALSE);
			item->inbag = NULL;
		
		}

		item->stacked = NULL;
		item->inside = NULL;

		g_free(item);
		item = NULL;

	}

}

